// SUBNETWORK HIERARCHIES OF BIOCHEMICAL NETWORKS ========================
// by Petter Holme, April 2002 ===========================================

#include "net.h"

SD sd;
int clnr;
extern int *iv;
extern char fname[NAMESIZE], metatag[3];
extern NODE *node;
extern PAR par;
     
//------------------------------------------------------------------------

INLINE int sd1 () {
  int i, j, me, nnexttmp = 0;
  
  for (i = 0; i < sd.nnext; i++) {
    me = sd.next[i];
    for (j = 0; j < node[me].outdegree; j++)
      if (!sd.distlist[node[me].outneighbor[j]]) {
	sd.nexttmp[nnexttmp++] = node[me].outneighbor[j];
	sd.distlist[node[me].outneighbor[j]] = clnr;
	sd.step++; sd.n++;
      }
    for (j = 0; j < node[me].indegree; j++)
      if (!sd.distlist[node[me].inneighbor[j]]) {
	sd.nexttmp[nnexttmp++] = node[me].inneighbor[j];
	sd.distlist[node[me].inneighbor[j]] = clnr;
	sd.step++; sd.n++;
      }
  }
  sd.nexttmptmp = sd.next;
  sd.next = sd.nexttmp;
  sd.nexttmp = sd.nexttmptmp;
  sd.nnext = nnexttmp;
  if (nnexttmp) return sd1();
  else return 0;
}

//------------------------------------------------------------------------

int cluster_statistics () {
  int i, lasti = 0, cmax = 0;

  clnr = 0;
  for (i = 0; i < par.n; i++) sd.distlist[i] = 0;
  sd.n = 0;

  while (par.n > sd.n) {
    i = lasti;
    while (sd.distlist[i]) i++;
    lasti = i + 1;
    sd.distlist[i] = ++clnr;
    sd.nnext = sd.step = 1;
    sd.n++;
    sd.next[0] = i;
    sd1();
  }
  
  // save cluster index . . .
  for (i = 0; i < par.n - par.nreaction; i++) *iv++ = sd.distlist[i];
  return cmax;
}

//------------------------------------------------------------------------

void measure () {
  int i;
  double *bnode;
  
  sd.distlist = (int *) malloc(3 * par.n * sizeof(int));
  sd.nexttmp = sd.distlist + par.n;
  sd.next = sd.nexttmp + par.n;
  sd.n = par.n;
  
  bnode = (double *) calloc(par.n, sizeof(double));
  
  for (i = 0; i <= par.nreaction; i++) { // for each reaction node . . .
    cluster_statistics();
    if (i < par.nreaction) attack(bnode);
  }
  free(sd.distlist); free(bnode);
}

//------------------------------------------------------------------------

void save_data (int *piv) {
  char filename[NAMESIZE + 5], prefix[6];
  FILE *fp;

  sprintf(prefix, "data/");
  sprintf(filename, "%s%s", prefix, fname);
  fp = fopen(filename, "wb");
  if (fp == NULL) {printf("---- can't open %s\n", filename); return;}
  fwrite(piv, sizeof(int),
	 (1 + par.nreaction) * (par.n - par.nreaction), fp);
  fclose(fp);
}

//------------------------------------------------------------------------
