// SUBNETWORK HIERARCHIES OF BIOCHEMICAL NETWORKS ========================
// by Petter Holme, April 2002 ===========================================

// just a heapsort indexing routine . . .

#include "net.h"

#define SWAP(a,b) {itmp = (a); (a) = (b); (b) = itmp;}
#define M 7
#define NSTK 50 // this sould do for networks with less than 10^15
//                 substances

//------------------------------------------------------------------------

void inx (int n, int *iv, int *inx) {
  int i, inxt, ir = n - 1, itmp, j, k, l = 0, jstk = 0, a, *istk;

  istk = (int *) malloc(NSTK * sizeof(int));
  for (j = 0; j < n; j++) inx[j] = j;
  for ( ; ; ) {
    if (ir - l < M) {
      for (j = l + 1; j <= ir; j++) {
	inxt = inx[j];
	a = iv[inxt];
	for (i = j - 1; i >= 0; i--) {
	  if (iv[inx[i]] <= a) break;
	  inx[i + 1] = inx[i];
	}
	inx[i + 1] = inxt;
      }
      if (jstk == 0) break;
      ir = istk[jstk--];
      l = istk[jstk--];
    } else {
      k = (l + ir) >> 1;
      SWAP(inx[k], inx[l + 1]);
      if (iv[inx[l + 1]] > iv[inx[ir]]) SWAP(inx[l + 1], inx[ir]);
      if (iv[inx[l]] > iv[inx[ir]]) SWAP(inx[l], inx[ir]);
      if (iv[inx[l + 1]] > iv[inx[l]]) SWAP(inx[l + 1], inx[l]);
      i = l + 1;
      j = ir;
      inxt = inx[l];
      a = iv[inxt];
      for ( ; ; ) {
	do i++; while (iv[inx[i]] < a);
	do j--; while (iv[inx[j]] > a);
	if (j < i) break;
	SWAP(inx[i], inx[j]);
      }
      inx[l] = inx[j];
      inx[j] = inxt;
      jstk += 2;
      if (ir - i + 1 >= j - l) {
	istk[jstk] = ir;
	istk[jstk - 1] = i;
	ir = j - 1;
      } else {
	istk[jstk] = j - 1;
	istk[jstk - 1] = l;
	l = i;
      }
    }
  }
  free(istk);
}

//------------------------------------------------------------------------
