// SUBNETWORK HIERARCHIES OF BIOCHEMICAL NETWORKS ========================
// by Petter Holme, April 2002 ===========================================
// e-mail: holme@tp.umu.se ===============================================

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <fcntl.h>
#include <ctype.h>

#define NAMESIZE 40
#define INLINE inline
#define REALLOC 10
#define M0 1000000
#define M1 1000001
#define EPS 1.0e-6
#define PAJEKMAX 10
#define META 0
#define CELL 1

// this struct contains genral parameters:
//       org -- the organism-index in the file 'orgnames'
//      mode -- metabolic ('META') or whole-cell ('CELL') network
//         n -- total numer of nodes
// nreaction -- number of reaction nodes
typedef struct PAR {
  int org, mode, n, nreaction;
} PAR;

// this struct contains information for the recursion in for
// measuring cluster statistics
typedef struct SD {
  int n, end, step, *next, *nexttmp, *nexttmptmp, *distlist, nnext;
} SD;

// this struct contains local information about a node and it's
// surroundings . . . (should be self-explanatory)
typedef struct NODE {
  int indegree, outdegree, *inneighbor, *outneighbor;
  double betweenness;
} NODE;

// in 'hierarchy.c' . . .
extern void save_data (int *);
extern void measure();

// in 'attack.c' . . .
extern void attack (double *);

// in 'index.c' . . .
extern void inx (int, int *, int *);
